.\" Copyright (c) 1980, 1989, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)mount.8	8.7 (Berkeley) 3/27/94
.\" $FreeBSD: src/sbin/mount/mount.8,v 1.11.2.6 1999/09/05 11:24:03 peter Exp $
.\"
.Dd March 27, 1994
.Dt MOUNT 8
.Os BSD 4
.Sh NAME
.Nm mount
.Nd mount file systems
.Sh SYNOPSIS
.Nm mount
.Op Fl adfpruvw
.Op Fl t Ar ufs | lfs | external_type
.Nm mount
.Op Fl dfpruvw
.Ar special | node
.Nm mount
.Op Fl dfpruvw
.Op Fl o Ar options
.Op Fl t Ar ufs | lfs | external_type
.Ar special node
.Sh DESCRIPTION
The
.Nm mount
command
calls the
.Xr mount 2
system call to prepare and graft a
.Ar "special device"
or the remote node (rhost:path) on to the file system tree at the point
.Ar node .
If either
.Ar special
or
.Ar node
are not provided, the appropriate information is taken from the
.Xr fstab 5
file.
.Pp
The system maintains a list of currently mounted file systems.
If no arguments are given to
.Nm mount ,
this list is printed.
.Pp
The options are as follows:
.Bl -tag -width indent
.It Fl a
Causes all filesystems listed in
.Pa /etc/fstab
(except those with the ``noauto'' option) to be mounted. This is normally
done during system startup.
.It Fl d
Causes everything to be done except for the actual system call.
This option is useful in conjunction with the
.Fl v
flag to
determine what the
.Nm mount
command is trying to do.
.It Fl f
Forces the revocation of write access when trying to downgrade
a filesystem mount status from read-write to read-only. Also
forces the R/W mount of an unclean filesystem (dangerous; use with
caution).
.It Fl o
Options are specified with a
.Fl o
flag followed by a comma separated string of options.
The following options are available:
.Bl -tag -width indent
.It async
All
.Tn I/O
to the file system should be done asynchronously.
This is a
.Em dangerous
flag to set,
and should not be used unless you are prepared to recreate the file
system should your system crash.
.It force
The same as
.Fl f ;
forces the revocation of write access when trying to downgrade
a filesystem mount status from read-write to read-only. Also
forces the R/W mount of an unclean filesystem (dangerous; use with caution).
.It noatime
Do not update the file access time when reading from a file. This option
is useful on filesystems where there are large numbers of files and
performance is more critical than updating the file access time (which is
rarely ever important). This option is currently only supported on local
filesystems.
.It nodev
Do not interpret character or block special devices on the file system.
This option is useful for a server that has file systems containing
special devices for architectures other than its own.
.It noexec
Do not allow execution of any binaries on the mounted file system.
This option is useful for a server that has file systems containing
binaries for architectures other than its own.
.It nosuid
Do not allow set-user-identifier or set-group-identifier bits to take effect.
Note: this option is worthless if a public available suid or sgid
wrapper like
.Xr suidperl
is installed on your system.
.It rdonly
The same as
.Fl r ;
mount the file system read-only (even the super-user may not write it).
.It sync
All
.Tn I/O
to the file system should be done synchronously.
.It update
The same as
.Fl u ;
indicate that the status of an already mounted file system should be changed.
.It union
Causes the namespace at the mount point to appear as the union
of the mounted filesystem root and the existing directory.
Lookups will be done in the mounted filesystem first.
If those operations fail due to a non-existent file the underlying
directory is then accessed.
All creates are done in the mounted filesystem.
.El
.Pp
Any additional options specific to a filesystem type that is not
one of the internally known types (see the
.Fl t
option) may be passed as a comma separated list; these options are
distinguished by a leading
.Dq \&-
(dash).
Options that take a value are specified using the syntax -option=value.
For example, the
.Nm
command:
.Bd -literal -offset indent
mount -t mfs -o nosuid,-N,-s=4000 /dev/dk0b /tmp
.Ed
.Pp
causes
.Nm mount
to execute the equivalent of:
.Bd -literal -offset indent
/sbin/mount_mfs -o nosuid -N -s 4000 /dev/dk0b /tmp
.Ed
.It Fl p
Print mount information in fstab format. Implies also the
.Fl v
option.
.It Fl r
The file system is to be mounted read-only.
Mount the file system read-only (even the super-user may not write it).
The same as the
.Dq rdonly
argument to the
.Fl o
option.
.It Fl t Ar "ufs \\*(Ba lfs \\*(Ba external type"
The argument following the
.Fl t
is used to indicate the file system type.
The type
.Ar ufs
is the default.
The 
.Fl t
option can be used
to indicate that the actions should only be taken on
filesystems of the specified type.
More than one type may be specified in a comma separated list.
The list of filesystem types can be prefixed with
.Dq no
to specify the filesystem types for which action should
.Em not
be taken.
For example, the
.Nm mount
command:
.Bd -literal -offset indent
mount -a -t nonfs,mfs
.Ed
.Pp
mounts all filesystems except those of type
.Tn NFS
and
.Tn MFS .
.Pp
If the type is not one of the internally known types,
.Nm
will attempt to execute a program in
.Pa /sbin/mount_ Ns Em XXX
where
.Em XXX
is replaced by the type name.
For example, nfs filesystems are mounted by the program
.Pa /sbin/mount_nfs .
.Pp
Most filesystems will be dynamically loaded by their mount programs
if not already present in the kernel, using the
.Xr vfsload 3
subroutine.  Because this mechanism requires writable temporary space,
the filesystem type containing
.Pa /tmp
must be compiled into the kernel, and the filesystems containing
.Pa /tmp 
and
.Pa /usr/bin/ld 
must be listed in
.Pa /etc/fstab
before any filesystems which might be dynamically loaded.
.It Fl u
The
.Fl u
flag indicates that the status of an already mounted file
system should be changed.
Any of the options discussed above (the
.Fl o
option)
may be changed;
also a file system can be changed from read-only to read-write
or vice versa.
An attempt to change from read-write to read-only will fail if any
files on the filesystem are currently open for writing unless the
.Fl f
flag is also specified.
The set of options is determined by first extracting the options
for the file system from the
.Xr fstab 5
table,
then applying any options specified by the
.Fl o
argument,
and finally applying the
.Fl r
or
.Fl w
option.
.It Fl v
Verbose mode.
.It Fl w
The file system object is to be read and write.
.Pp
The options specific to NFS filesystems are described in the
.Xr mount_nfs 8
manual page.
.Sh DIAGNOSTICS
Various, most of them are self-explanatory.
.Pp
.Dl XXXXX filesystem is not available
.Pp
The kernel doesn't support the respective filesystem type.  Note that
support for a particular filesystem might be provided either on a static
(kernel compile-time), or dynamic basis (loaded as a kernel module by
.Xr modload 8 ).
Normally,
.Nm
or its subprocesses attempt to dynamically load a filesystem module if
it hasn't been configured statically, using
.Xr vfsload 3 .
In this case, the above error message can also mean that you didn't
have permission to load the module.
.Sh FILES
.Bl -tag -width /etc/fstab -compact
.It Pa /etc/fstab
file system table
.El
.Sh SEE ALSO
.Xr mount 2 ,
.Xr vfsload 3 ,
.Xr fstab 5 ,
.Xr mount_cd9660 8 ,
.Xr mount_devfs 8 ,
.Xr mount_fdesc 8 ,
.Xr mount_kernfs 8 ,
.Xr mount_lfs 8 ,
.Xr mount_mfs 8 ,
.Xr mount_msdos 8 ,
.Xr mount_nfs 8 ,
.Xr mount_null 8 ,
.Xr mount_portal 8 ,
.Xr mount_procfs 8 ,
.Xr mount_umap 8 ,
.Xr mount_union 8 ,
.Xr umount 8
.Sh BUGS
It is possible for a corrupted file system to cause a crash.
.Sh CAVEATS
After a successful mount, the permissions on the original mount point 
determine if 
.Pa ".."
is accessible from the mounted file system.  The minimum permissions for
the mount point for traversal across the mount point in both 
directions to be possible for all users is 0111 (execute for all).
.Sh HISTORY
A
.Nm mount
command appeared in
.At v1 .
